<template>
    <q-page class="fit">
        <q-tab-panels animated keep-alive transition-prev="slide-down" transition-next="slide-up" vertical
            v-model="$store.state.activeModule">
            <q-tab-panel v-for="moduleComponent, index in moduleComponents" :key="index"
                :name="moduleComponent.module.ID">
                <component :is="moduleComponent.component" :module="moduleComponent.module"
                    v-if="moduleComponent.module !== undefined" />
            </q-tab-panel>
        </q-tab-panels>
    </q-page>
</template>

<script>
export default {
    data() {
        return {
            moduleComponents: []
        }
    },
    watch: {
        modules(val) {
            console.log('modules triggered')
            this.loadComponents()
        }
    },
    computed: {
        modules() {
            if (this.$store.state.activeMainMenu === null) {
                return []
            }
            return this.$store.state.modules.filter((module) => {
                return module.Menu_Relation_ID === this.$store.state.activeMainMenu?.ID
            })
        }
    },
    methods: {
        loadComponents() {
            const self = this
            this.moduleComponents = this.modules.map((module) => {
                return {
                    module,
                    component: Vue.defineAsyncComponent(() => import(`components/modules/${module.Module_Name}.vue`))
                }
            })
        }
    }
}
</script>
